// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

Slayer.Gamemodes.addMode("One Man Army","OMA",1,1);

Slayer.Prefs.addPref("OMA","Boss Health Modifier","%mini.OMA_bossHealthModifier","slide 0 5 24 1",0.8,0,1,-1,"Rules OMA Player");
Slayer.Prefs.addPref("OMA","Boss Size","%mini.OMA_bossScale","slide 0 5 4 1",1,0,1,-1,"Rules OMA Player","Slayer_OMA_updateBossScale(%mini,%1);");
Slayer.Prefs.addPref("OMA","Display Boss Health","%mini.OMA_displayBossHealth","bool",1,0,1,-1,"Rules OMA Mode");
Slayer.Prefs.addPref("OMA","Enable Damage Records","%mini.OMA_damageRecords","bool",1,0,1,-1,"Rules OMA Mode");
Slayer.Prefs.addPref("OMA","Enable Survival Records","%mini.OMA_survivalRecords","bool",0,0,1,-1,"Rules OMA Mode");
Slayer.Prefs.addPref("OMA","Boss Team","%mini.OMA_bossName","string 50","Boss",0,0,3,"Advanced");

function Slayer_OMA_onRules(%mini,%client)
{
	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	//SURVIVAL RECORDS
	%rh = %mini.OMA_recordHolder;
	%rt = %mini.OMA_recordTime;
	if(%mini.OMA_survivalRecords && %rt > 0 && isObject(%rh))
	{
		%t = getDisplayTime(%mini.OMA_recordTime);

		%hours = getField(%t,0);
		%minutes = getField(%t,1);
		%seconds = getField(%t,2);

		if(%hours >= 1)
			%time = "\c3" @ %hours SPC (%hours == 1 ? "\c5hour" : "\c5hours") @ ", ";
		if(%minutes >= 1)
			%time = %time @ "\c3" @ %minutes SPC (%minutes == 1 ? "\c5minute" : "\c5minutes") @ (%hours >= 1 ? ", and " : " and ");
		%time = %time @ "\c3" @ %seconds SPC (%seconds == 1 ? "\c5second" : "\c5seconds");

		messageClient(%client,'',"\c5 + \c3" @ %rh.getPlayerName() SPC "\c5holds the record, having survived for" SPC %time @ "."); //SPC "and killed\c3" SPC %rk SPC (%rk == 1 ? "\c5opponent" : "\c5opponents") @ ".");
	}

	if(%client.getTeam() == %bossTeam)
		messageClient(%client,'',"\c5 + \c3You \c5are currently the Boss. Survive as long as possible!");
	else if(%bossTeam.numMembers > 0)
	{
		%client.ignoreSpam = 1; //prevents Slayer's serverCmd spam filter from blocking this
		serverCmdTeams(%client,listMembers,%bossTeam.name);
	}
}

function Slayer_OMA_onSpawn(%mini,%client)
{
	if(!isObject(%client.player))
		return;

	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	if(%client.getTeam() == %bossTeam)
	{
		%size = %mini.OMA_bossScale;
		%client.player.setScale(%size SPC %size SPC %size);
	}
}

function Slayer_OMA_postDeath(%mini,%client,%obj,%killer,%type,%area)
{
	%clTeam = %client.getTeam();
	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	if(%clTeam != %bossTeam)
		return;

	if(isObject(%killer) && %killer != %client && %killer.getTeam() != %clTeam)
		%killer.incScore(-%mini.points_killPlayer);

	if(!%client.dead())
		return;

	//SURVIVAL TIME RECORDS
	%client.OMA_recordTime = getSimTime() - %mini.roundStarted();
	if(%mini.OMA_survivalRecords && (%client.OMA_recordTime > %mini.OMA_recordTime || !isObject(%mini.OMA_recordHolder)))
	{
		%mini.OMA_recordTime = %client.OMA_recordTime;
		// %mini.OMA_recordKills = %client.getKills();
		%mini.OMA_recordHolder = %client;

		%t = getDisplayTime(%mini.OMA_recordTime);

		%hours = getField(%t,0);
		%minutes = getField(%t,1);
		%seconds = getField(%t,2);

		if(%hours >= 1)
			%time = "\c3" @ %hours SPC (%hours == 1 ? "\c5hour" : "\c5hours") @ ", ";
		if(%minutes >= 1)
			%time = %time @ "\c3" @ %minutes SPC (%minutes == 1 ? "\c5minute" : "\c5minutes") @ (%hours >= 1 ? ", and " : " and ");
		%time = %time @ "\c3" @ %seconds SPC (%seconds == 1 ? "\c5second" : "\c5seconds");

		%mini.messageAll('',"\c5 + \c3" @ %client.getPlayerName() SPC "\c5just set a new record, having survived for" SPC %time @ "!"); //SPC "and killed\c3" SPC %mini.OMA_recordKills SPC (%mini.OMA_recordKills == 1 ? "\c5opponent" : "\c5opponents") @ "!");
	}
}

function Slayer_OMA_postVictory(%mini,%winner,%nameList)
{
	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	//DAMAGE SUMMARY
	if(%mini.OMA_damageRecords)
	{
		%greatest = 0;
		for(%i=0; %i < %mini.numMembers; %i++)
		{
			%cl = %mini.member[%i];
			%dmg = %cl.OMA_damageDealt;
	
			if(%dmg > %greatest)
				%greatest = %dmg;
		}
		for(%i=0; %i < %mini.numMembers; %i++)
		{
			%cl = %mini.member[%i];
			if(%cl.slyrTeam == %bossTeam)
				continue;
	
			%dmg = %cl.OMA_damageDealt;
			if(%dmg $= "")
				%dmg = 0;

			if(%greatest > 0)
			{
				if(%dmg >= %greatest)
					messageClient(%cl,'',"\c5 + \c3You \c5did the most damage to the boss, with\c3" SPC %dmg SPC (%dmg == 1 ? "\c5point" : "\c5points") SPC "of damage dealt.");
				else
					messageClient(%cl,'',"\c5 + The most damage done to the boss was\c3" SPC %greatest SPC (%greatest == 1 ? "\c5point" : "\c5points") @ ". You did\c3" SPC %dmg SPC (%dmg == 1 ? "\c5point" : "\c5points") SPC "of damage.");
			}
			else
				messageClient(%cl,'',"\c5 + Nobody damaged the boss this round.");
		}
	}
}

function Slayer_OMA_scoreListInit(%mini,%header,%var1,%var2,%var3,%var4,%var5,%var6,%var7,%var8,%var9)
{
	%header = '<color:ffffff><tab:150,250,325,450><font:arial:16>%1<h2>%2\t%3\t%4\t%5\t%6</h2><br>';
	%var5 = "Boss Damage";
	return true TAB %header TAB %var1 TAB %var2 TAB %var3 TAB %var4 TAB %var5 TAB %var6;
}

function Slayer_OMA_scoreListAdd(%mini,%obj,%line,%var1,%var2,%var3,%var4,%var5,%var6,%var7,%var8,%var9)
{
	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	if(%obj.getClassName() $= "GameConnection")
	{
		if(%obj.getTeam() == %bossTeam)
			%bossDamage = "---";
		else
			%bossDamage = %obj.OMA_damageDealt;
	}
	else if(%mini.Teams.isMember(%obj))
	{
		if(%obj == %bossTeam)
			%bossDamage = "---";
		else
			%bossDamage = %obj.OMA_getBossDamageDealt();
	}
	else
		return false;
	%var5 = %bossDamage;
	return true TAB %line TAB %var1 TAB %var2 TAB %var3 TAB %var4 TAB %var5 TAB %var6;
}

function Slayer_OMA_preReset(%mini)
{
	Slayer_OMA_setUpMini(%mini);

	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);
	if(%bossTeam.maxPlayers < 0)
		%bossTeam.maxPlayers = 0;

	for(%i=%bossTeam.numMembers-1; %i >= 0; %i--)
	{
		%cl = %bossTeam.member[%i];
		%bossTeam.removeMember(%cl);

		%t = %mini.Teams.pickTeam(%cl);
		if(isObject(%t))
			%t.addMember(%cl,"",1);
	}

	if(%mini.numMembers > 1)
	{
		for(%i=0; %i < %bossTeam.maxPlayers; %i++)
		{
			%boss = Slayer_OMA_pickBoss(%mini);
			if(isObject(%boss))
				%bossTeam.addMember(%boss,"",1);
		}
	}

	for(%i=0; %i < %mini.numMembers; %i++)
		%mini.member[%i].OMA_damageDealt = 0;
}

function Slayer_OMA_onLeave(%mini,%client)
{
	for(%i=0; %i < getFieldCount(%mini.OMA_bossList); %i++)
	{
		%cl = getField(%mini.OMA_bossList,%i);
		if(%cl == %client)
		{
			%mini.OMA_bossList = removeField(%mini.OMA_bossList,%i);
			break;
		}
	}
}

function Slayer_OMA_setUpMini(%mini)
{
	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);
	if(!isObject(%bossTeam))
	{
		%bossTeam = %mini.Teams.addTeam();

		%bossTeam.setPref("Team","Name",%mini.OMA_bossName);
		%bossTeam.setPref("Team","Color",0);
		%bossTeam.setPref("Team","Max Players",1);
		%bossTeam.setPref("Team","Lock Team",1);
		%bossTeam.setPref("Team","Uniform",2);
		%bossTeam.setPref("Team","Lives",1);
		%bossTeam.setPref("Team","Enable Team Chat",0);
		for(%i=0; %i < 5; %i++)
			%bossTeam.setPref("Team","Start Equip" SPC %i,%mini.startEquip[%i]);
		%bossTeam.setPref("Team","Playertype",%mini.playerDatablock);
	}

	//these values always need to be applied to the boss team
	%bossTeam.setPref("Team","Auto Sort",0);
	%bossTeam.setPref("Team","Auto Sort Weight",0);

	if(%mini.Teams.getAutosortTeamCount() < 1)
	{
		%otherTeam = %mini.Teams.addTeam();

		%otherTeam.setPref("Team","Name","Normals");
		%otherTeam.setPref("Team","Color",2);
		%otherTeam.setPref("Team","Max Players",-1);
		%otherTeam.setPref("Team","Uniform",0);
		for(%i=0; %i < 5; %i++)
			%otherTeam.setPref("Team","Start Equip" SPC %i,%mini.startEquip[%i]);
		%otherTeam.setPref("Team","Playertype",%mini.playerDatablock);

		for(%i = 0; %i < %mini.numMembers; %i ++)
		{
			%cl = %mini.member[%i];
			if(!isObject(%cl.getTeam()))
				%otherTeam.addMember(%cl);
		}
	}
}

function Slayer_OMA_pickBoss(%mini)
{
	if(!isSlayerMinigame(%mini))
		return;

	if(%mini.numMembers < 1)
		return 0;

	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	if(!isObject(%bossTeam))
	{
		%mini.messageAll('',"ERROR: Boss team not found, aborting.");
		return;
	}

	if(%mini.OMA_bossList $= "") //bossList generation
	{
		for(%i=0; %i < %mini.numMembers; %i++)
		{
			%cl = %mini.member[%i];
			if(%cl.getTeam() == %bossTeam)
				continue;

			%mini.OMA_bossList = setField(%mini.OMA_bossList,%i,%cl);
		}
	}

	%r = getRandom(0,getFieldCount(%mini.OMA_bossList)-1);
	%cl = getField(%mini.OMA_bossList,%r);

	%mini.OMA_bossList = removeField(%mini.OMA_bossList,%r);

	if(%bossTeam == %cl.getTeam() && %mini.numMembers - %bossTeam.numMembers > 0)
		return Slayer_OMA_pickBoss(%mini);

	return %cl;
}

function Slayer_OMA_updateBossScale(%mini,%flag)
{
	if(%mini.mode !$= "OMA")
		return;

	%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

	for(%i=0; %i < %bossTeam.numMembers; %i++)
	{
		%cl = %bossTeam.member[%i];
		if(isObject(%cl.player))
			%cl.player.setScale(%flag SPC %flag SPC %flag);
	}
}

function getDisplayTime(%time)
{
	%hours = mFloor(%time / 3600000);
	%minutes = mFloor((%time % 3600000) / 60000);
	%seconds = mFloor((%time % 3600000 % 60000) / 1000);

	return %hours TAB %minutes TAB %seconds;
}

function Slayer_TeamSO::OMA_getBossDamageDealt(%this)
{
	%dmg = 0;
	for(%i = 0; %i < %this.numMembers; %i ++)
		%dmg += %this.member[%i].OMA_damageDealt;
	return %dmg;
}

package Slayer_Gamemode_OMA
{
	function Player::Damage(%this,%obj,%pos,%damage,%type)
	{
		%db = %this.getDatablock();
		%attacker = %obj.client;
		%client = %this.client;

		if(isObject(%client) && %client.getClassName() $= "GameConnection")
		{
			%mini = getMinigameFromObject(%client);

			if(isSlayerMinigame(%mini) && %mini.mode $= "OMA")
			{
				%team = %client.getTeam();
				%bossTeam = %mini.Teams.getTeamFromName(%mini.OMA_bossName);

				%miniMembers = %mini.numMembers;
				%bossMembers = %bossTeam.numMembers;

				if(%team == %bossTeam)
				{
					//FIND THE MAX HEALTH
					%modifier = %mini.OMA_bossHealthModifier;
					%maxHealth = mPow(%miniMembers - %bossMembers + 2,2) * 15 * %modifier + %db.maxDamage;

					//DAMAGE PERCENT
					%damage = %damage / (%maxHealth / 100);

					//PER PLAYER DAMAGE COUNTS
					if(isObject(%attacker) && %attacker != %client)
					{
						%pts = mCeil(%damage);

						%attacker.incScore(%pts);
						%attacker.OMA_damageDealt += %pts;
					}

					%parent = parent::damage(%this,%obj,%pos,%damage,%type);

					//DISPLAY HEALTH
					%hp = mFloor(100 - %this.getDamagePercent() * 100);
					if(%mini.OMA_displayBossHealth)
						%mini.bottomPrintAll("\c5Boss Health (" @ %bossTeam.getColorHex() @ %client.getPlayerName() @ "\c5):\c3" SPC %hp @ "%",5);

					return %parent;
				}
			}
		}

		return parent::damage(%this,%obj,%pos,%damage,%type);
	}
};
activatePackage(Slayer_Gamemode_OMA);